using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using com.ibm.gre;

namespace SampleApp
{
	/// <summary>
	/// The TransitionResultsForm displays a list of Transition Results.
	/// </summary>
	public class TransitionResultsForm : System.Windows.Forms.Form
	{
		public TransitionResultsForm(ClientSession session, Control parent, IRMList list)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			util = new Util(this,parent);
			m_session = session;
			m_IRMList = list;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void DrawTransitionResults()
		{
			lvTransitionResults.Items.Clear();
			lvTransitionResults.Columns.Clear();

			float totalWidth = lvTransitionResults.Width;
			
			int width = (int)(.4 * totalWidth);
			lvTransitionResults.Columns.Add("Task Name",width,HorizontalAlignment.Left);
			width = (int)(.2 * totalWidth);
			lvTransitionResults.Columns.Add("Status",width,HorizontalAlignment.Left);
			width = (int)(.2 * totalWidth);
			lvTransitionResults.Columns.Add("Start Time",width,HorizontalAlignment.Left);
			width = (int)(.1 * totalWidth);
			lvTransitionResults.Columns.Add("% Done",width,HorizontalAlignment.Left);
			width = (int)(.1 * totalWidth);
			lvTransitionResults.Columns.Add("Status Time",width,HorizontalAlignment.Left);

			for(int i = 0; i < m_IRMList.Count; i++)
			{
				ListViewItem item = new ListViewItem(m_IRMList.Caption(i));
				
				string strStatus = m_IRMList.getAttributeValue(i,"Status");
				int nStatus = Convert.ToInt32(strStatus);
				item.SubItems.Add(Util.makeStatusMsg(nStatus));
				item.SubItems.Add(m_IRMList.getAttributeValue(i,"StartTime"));
				item.SubItems.Add(strStatus);
				item.SubItems.Add(m_IRMList.getAttributeValue(i,"StatusTime"));

				item.Tag = m_IRMList.PrimaryKey(i);
				lvTransitionResults.Items.Add(item);
			}
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lvTransitionResults = new System.Windows.Forms.ListView();
			this.SuspendLayout();
			// 
			// lvTransitionResults
			// 
			this.lvTransitionResults.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvTransitionResults.FullRowSelect = true;
			this.lvTransitionResults.Location = new System.Drawing.Point(0, 0);
			this.lvTransitionResults.Name = "lvTransitionResults";
			this.lvTransitionResults.Size = new System.Drawing.Size(592, 277);
			this.lvTransitionResults.TabIndex = 0;
			this.lvTransitionResults.View = System.Windows.Forms.View.Details;
			// 
			// TransitionResultsForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 277);
			this.Controls.Add(this.lvTransitionResults);
			this.Name = "TransitionResultsForm";
			this.Text = "TransitionResultsForm";
			this.Load += new System.EventHandler(this.TransitionResultsForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void TransitionResultsForm_Load(object sender, System.EventArgs e)
		{
			DrawTransitionResults();
		}

		#region MemberVariables
		private Util util;
		private ClientSession m_session;
		private IRMList m_IRMList;
		private System.Windows.Forms.ListView lvTransitionResults;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		#endregion

	}
}
