<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
				version="1.0" 
				xmlns:fo="http://www.w3.org/1999/XSL/Format"
				xmlns:exsl="http://exslt.org/common"
				extension-element-prefixes="exsl">

	<xsl:key name="itemByUsrNm" match="/ResultList/Data/List/Item" use="@TS_UsrDir.UsrNm" />
	<xsl:key name="itemBySecClsNm" match="/ResultList/Data/List/Item" use="concat(@TS_UsrDir.UsrNm,' ',@TS_SecCls.SecClsNm)" />
	<xsl:key name="itemBySecDescNm" match="/ResultList/Data/List/Item" use="concat(@TS_UsrDir.UsrNm,' ',@TS_SecDesc.SecDescNm)" />
	<xsl:key name="itemByGrpNm" match="/ResultList/Data/List/Item" use="concat(@TS_UsrDir.UsrNm,' ',@TS_GrpDir.GrpNm)" />

	<xsl:template match="/">
		<fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">

			<!-- defines page layout -->
			<fo:layout-master-set>
				<fo:simple-page-master master-name="simple" page-width="28cm" page-height="22cm" margin-top="0.5cm" margin-bottom="0.5cm" margin-left="0.5cm" margin-right="0.5cm">
					<fo:region-before extent="0.5cm"/>
					<fo:region-body margin-top="0.5cm" margin-bottom="0.5cm"/>
				</fo:simple-page-master>
			</fo:layout-master-set>


			<!-- defines the content -->
			<fo:page-sequence master-reference="simple">
				<fo:static-content flow-name="xsl-region-before" font-size="8pt">
					<fo:block  text-align="right">
					<fo:page-number/>
					<fo:inline>/</fo:inline>
					<fo:page-number-citation ref-id="terminator"/>
					</fo:block>
				</fo:static-content>

				<fo:flow flow-name='xsl-region-body'>
					<fo:block font-size="14pt" font-weight="bold" text-align="center">
					Users, Access groups, Protective markings and roles Report
					</fo:block>
				
					<fo:table font-size="8pt" border="1">
						<!-- total 27cm -->
						<fo:table-column column-width="5cm" />
						<fo:table-column column-width="5cm" />
						<fo:table-column column-width="6cm" />
						<fo:table-column column-width="6cm" />						
						<fo:table-column column-width="5cm" />						

						<!-- Header -->
					
						<fo:table-header font-weight="bold" color="white" background-color="gray">
							<fo:table-row>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									User
									</fo:block>
								</fo:table-cell>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									Group access list
									</fo:block>
								</fo:table-cell>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									Protective marking
									</fo:block>
								</fo:table-cell>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									Descriptor
									</fo:block>
								</fo:table-cell>
								<fo:table-cell padding="2pt" border="solid black">
									<fo:block>
									Role
									</fo:block>
								</fo:table-cell>
							</fo:table-row>
						</fo:table-header>

						<!-- File Plan -->
						<fo:table-body>
							<xsl:for-each select="/ResultList/Data/List/Item[count(. | key('itemByUsrNm', @TS_UsrDir.UsrNm)[1]) = 1]">
									<xsl:sort select="@TS_UsrDir.UsrNm" />

									<fo:table-row>
									
										<fo:table-cell padding="2pt" border="solid black">
											<fo:block text-align="start">

												<xsl:value-of select="@TS_UsrDir.UsrNm" />		 
											</fo:block>
										</fo:table-cell>
									
										<fo:table-cell padding="2pt" border="solid black">
											<xsl:for-each select="key('itemByUsrNm', @TS_UsrDir.UsrNm)">
											<xsl:sort select="@TS_GrpDir.GrpNm"/>										
											<xsl:if test="count(. | key('itemByGrpNm', concat(@TS_UsrDir.UsrNm,' ',@TS_GrpDir.GrpNm))[1]) = 1">
											<fo:block text-align="start">
												<xsl:value-of select="@TS_GrpDir.GrpNm" />
											</fo:block>
											</xsl:if>
											</xsl:for-each>
										</fo:table-cell>

										<fo:table-cell padding="2pt" border="solid black">
											<xsl:for-each select="key('itemByUsrNm', @TS_UsrDir.UsrNm)">
											<xsl:sort select="@TS_SecCls.SecClsNm"/>
											<xsl:if test="count(. | key('itemBySecClsNm', concat(@TS_UsrDir.UsrNm,' ',@TS_SecCls.SecClsNm))[1]) = 1">

											<fo:block text-align="start">
												<xsl:value-of select="@TS_SecCls.SecClsNm" />
											</fo:block>

											</xsl:if>

											</xsl:for-each>
										</fo:table-cell>

										<fo:table-cell padding="2pt" border="solid black">
											<xsl:for-each select="key('itemByUsrNm', @TS_UsrDir.UsrNm)">
											<xsl:sort select="@TS_SecDesc.SecDescNm"/>

											<xsl:if test="count(. | key('itemBySecDescNm', concat(@TS_UsrDir.UsrNm,' ',@TS_SecDesc.SecDescNm))[1]) = 1">																					
											<fo:block text-align="start">
												<xsl:value-of select="@TS_SecDesc.SecDescNm" />
											</fo:block>
											</xsl:if>
											</xsl:for-each>
										</fo:table-cell>

										<fo:table-cell padding="2pt" border="solid black">
											<xsl:for-each select="key('itemByUsrNm', @TS_UsrDir.UsrNm)[@TS_GrpDir.IsPrimaryGroup='1']">
											<xsl:sort select="@TS_GrpDir.GrpNm"/>										
											<xsl:if test="count(. | key('itemByGrpNm', concat(@TS_UsrDir.UsrNm,' ',@TS_GrpDir.GrpNm))[1]) = 1">
											<fo:block text-align="start">
												<xsl:value-of select="@TS_GrpDir.GrpNm" />
											</fo:block>
											</xsl:if>
											</xsl:for-each>
										</fo:table-cell>

									</fo:table-row>

							</xsl:for-each>

						</fo:table-body>
					</fo:table>

					<fo:block id="terminator"/>

				</fo:flow>

			</fo:page-sequence>
		</fo:root>
	</xsl:template>

</xsl:stylesheet>